//+------------------------------------------------------------------+
//|                                       Support and Resistance.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Aaragorn"
#property link      "http://www.forex-tsd.com/members/aaragorn.html"
// This is an attempt to locate support and resistance and determine it's relative strength
// This is only looking at horizontal lines not sloping trendlines. The goal is not simply to look at
// support and resistance as the highest highs or lowest lows but based on the actual opens and closes.
// The same kind of assessment could be done on highs and lows but shouldn't be weighted the same. 
// Highs and lows are the markets expirements and opens and closes are the markets resolutions of those expirements.
// The other thing I would like to see developed is some sort of time decay factor but that may be getting ahead of this project. One thing at a time.

extern int NumberOfBars = 50;// it appears that anything over 50 crashes it when it runs this is very inadequate to the task presently
#define SIZE 50  // must be set to match NumberOfBars <--I would like to have this automatically match the external input so when you change that this updates but I don't know how to do it
static int Index = 0;
//used in the tally loops
static double Opens[ SIZE ] = { 0 };
static double Closes[ SIZE ] = { 0 };

static double OpenOLevels[ SIZE ] = { 0 };
static double OpenCLevels[ SIZE ] = { 0 };
static double CloseOLevels[ SIZE ] = { 0 };
static double CloseCLevels[ SIZE ] = { 0 };

static double OpenOMatches[ SIZE ] = { 0 };
static double OpenCMatches[ SIZE ] = { 0 };
static double CloseOMatches[ SIZE ] = { 0 };
static double CloseCMatches[ SIZE ] = { 0 };

// Used to concatenate the results
static int TotalOMatches[ SIZE ] = { 0 };
static int TotalCMatches[ SIZE ] = { 0 };
static int OpensInt[ SIZE ] = { 0 };//this is specific to the pairs which are formatted with 4 decimals like "1.2345" they are multiplied by 10000 to preserve the decimal
static int ClosesInt[ SIZE ] = { 0 };//this is specific to the pairs which are formatted with 4 decimals like "1.2345" they are multiplied by 10000 to preserve the decimal

// Used to recombine after concatenation
static double OpenConcats[ SIZE ] = { 0 };
static double CloseConcats[ SIZE ] = { 0 };
static double uniqueopenconcats[ SIZE ] = { 0 };
static double uniquecloseconcats[ SIZE ] = { 0 };



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----We tally the opens and closes of the Bars

   Print("Support and Resistance EA has started");
   int i = NumberOfBars;
   while(i>0)
     {
      Opens[i]  = iOpen(NULL, 0, i);
      Closes[i] = iClose(NULL, 0, i);
     i--;
     }


// We calculate the matches for each open with the other open bars in the current set +/- 1 pip counts as a match

   // This loop cycles each open bar thru the examination
   int ct=0;
   i = NumberOfBars; 
   for(ct=NumberOfBars;ct>0;ct--)   
      {
         double xt=Opens[i];
        // This loop counts matches for each bar with the other bars
         int cnt=0, match=0, t=NumberOfBars;
         for(cnt=NumberOfBars;cnt>0;cnt--)   
            {
              double tx=Opens[t];          
              if(xt==tx || xt==tx+Point || xt==tx-Point)
                 {
                 match++;
                 }
             t--;   
            }
        // We save the results for each bar
        OpenOMatches[i]=match;
        OpenOLevels[i]=xt;
        match=0;
          
        // We print the result
        //Print("Bar: ",i,"  Open O Level: ",OpenOLevels[i],"   Open O Matches: ",OpenOMatches[i]);       
      i--;
      }
 
   
      
// We calculate the matches for each open with the close bars in the current set +/- 1 pip counts as a match
     
   // This loop cycles each close bar thru the examination
   int ct2=0,i2=0;
   i2 = NumberOfBars; 
   for(ct2=NumberOfBars;ct2>0;ct2--)   
      {
         double xt2=Opens[i2];
        // This loop counts matches for each bar with the other bars
         int cnt2=0, match2=0, t2=NumberOfBars;
         for(cnt2=NumberOfBars;cnt2>0;cnt2--)   
            {
              double tx2=Closes[t2];          
              if(xt2==tx2 || xt2==tx2+Point || xt2==tx2-Point)
                 {
                 match2++;
                 }
             t2--;   
            }
        // We save the results for each bar
        OpenCMatches[i2]=match2;
        OpenCLevels[i2]=xt2;
        match2=0;


        // We print the result
        //Print("Bar: ",i2,"  Open C Level: ",OpenCLevels[i2],"   Open C Matches: ",OpenCMatches[i2]);       
      i2--;
      }   

// We calculate the matches for each close with the other closes bars in the current set +/- 1 pip counts as a match

   // This loop cycles each open bar thru the examination
   int ct1=0,i1=0;
   i1 = NumberOfBars; 
   for(ct1=NumberOfBars;ct1>0;ct1--)   
      {
         double xt1=Closes[i1];
        // This loop counts matches for each bar with the other bars
         int cnt1=0, match1=0, t1=NumberOfBars;
         for(cnt1=NumberOfBars;cnt1>0;cnt1--)   
            {
              double tx1=Closes[t1];          
              if(xt1==tx1 || xt1==tx1+Point || xt1==tx1-Point)
                 {
                 match1++;
                 }
             t1--;   
            }
        // We save the results for each bar
        CloseCMatches[i1]=match1;
        CloseCLevels[i1]=xt1;
        match1=0;
          
        // We print the result
        //Print("Bar: ",i1,"  Close C Level: ",CloseCLevels[i1],"   Close C Matches: ",CloseCMatches[i1]);       
      i1--;
      }
 
   
      
//  We calculate the matches for each close with the opens bars in the current set +/- 1 pip counts as a match
     
   //  This loop cycles each close bar thru the examination
   int ct3=0,i3=0;
   i3 = NumberOfBars; 
   for(ct3=NumberOfBars;ct3>0;ct3--)   
      {
         double xt3=Closes[i3];
         //  This loop counts matches for each bar with the other bars
         int cnt3=0, match3=0, t3=NumberOfBars;
         for(cnt3=NumberOfBars;cnt3>0;cnt3--)   
            {
              double tx3=Opens[t3];          
              if(xt3==tx3 || xt3==tx3+Point || xt3==tx3-Point)
                 {
                 match3++;
                 }
             t3--;   
            }
        // We save the results for each bar
        CloseOMatches[i3]=match3;
        CloseOLevels[i3]=xt3;
        match3=0;


        // We print the result
        //Print("Bar: ",i3,"  Close C Level: ",CloseOLevels[i3],"   Close O Matches: ",Close O Matches[i3]);       
      i3--;
      }
      
// We combine the matches from the opens and closes and make interger arrays of Opens and Closes for the histogram loop to use

   
    int ct4=0,i4=0;
    i4 = NumberOfBars;
    string OpenLevelMatches,CloseLevelMatches;
    for(ct4=NumberOfBars;ct4>0;ct4--)
      {
         TotalOMatches[i4] = OpenOMatches[i4] +  OpenCMatches[i4];
         TotalCMatches[i4] = CloseOMatches[i4] + CloseCMatches[i4];
         OpensInt[i4] = Opens[i4]*10000;
         ClosesInt[i4] = Closes[i4]*10000;

         //We combine the levels and matches
         OpenLevelMatches = StringConcatenate(OpensInt[i4],".",TotalOMatches[i4]);
         OpenConcats[i4] = StrToDouble(OpenLevelMatches);
         
         CloseLevelMatches = StringConcatenate(ClosesInt[i4],".",TotalCMatches[i4]);
         CloseConcats[i4] = StrToDouble(CloseLevelMatches);

         // We Print the tallies of the  matches
         //Print("Bar: ",i4," Array Concats: ",OpenConcats[i4],"  Concat: ",OpenLevelMatches," OpensInt: ",OpensInt[i4]," Opens: ",Opens[i4],"  Total Open Matches: ",TotalOMatches[i4]);
         //Print ("Bar: ",i4," Array Concats: ",CloseConcats[i4],"  Concat: ",CloseLevelMatches," ClosesInt: ",ClosesInt[i4]," Closes: ",Closes[i4],"  Total Close Matches: ",TotalCMatches[i4]);
         
         
                  //Print("Bar: ",i4,"Interger of OTotalM: ",OpensInt[i4],"  Total Open Matches: ",TotalOMatches[i4]," =  OoM: ",OpenOMatches[i4]," @L: ",OpenOLevels[i4],"   + OcM: ",OpenCMatches[i4]," @L: ",OpenCLevels[i4]);
                  //Print ("Bar: ",i4,"Interger of CTotalM: ",ClosesInt[i4],"  Total Close Matches: ",TotalCMatches[i4],"  = CoM: ",CloseOMatches[i4]," @L: ",CloseOLevels[i4],"  + CcM: ",CloseCMatches[i4]," @L: ",CloseCLevels[i4]);
                  //Print("Bar: ",i4," TotalM: ",Opens[i4],"  Total Open Matches: ",TotalOMatches[i4]," =  OoM: ",OpenOMatches[i4]," @L: ",OpenOLevels[i4],"   + OcM: ",OpenCMatches[i4]," @L: ",OpenCLevels[i4]);
                  //Print ("Bar: ",i4," TotalM: ",Closes[i4],"  Total Close Matches: ",TotalCMatches[i4],"  = CoM: ",CloseOMatches[i4]," @L: ",CloseOLevels[i4],"  + CcM: ",CloseCMatches[i4]," @L: ",CloseCLevels[i4]);

      i4--;
      }

    //We sort the results and reduce them to unique levels
    ArraySort(OpenConcats); 
    ArraySort(CloseConcats); 
      //ArrayBsearch
      
      int ct5=0,i5=NumberOfBars,i6=NumberOfBars-1;
      for(ct5=NumberOfBars;ct5>0;ct5--)
         {
         if(OpenConcats[i5]!=OpenConcats[i6])
            {
            uniqueopenconcats[i5] = OpenConcats[i5];
            }
         if(CloseConcats[i5]!=CloseConcats[i6])
            {
            uniquecloseconcats[i5] = CloseConcats[i5];
            }
            
         Print ("Bar: ",i5,"  Unique Open Concats : ",uniqueopenconcats[i5]/*,"  OpenConcats: ",OpenConcats[i5]*/); 
         //Print ("Bar: ",i6,"  Sorted Open Concats -1: ",OpenConcats[i6]);      
         Print ("Bar: ",i5,"  Unique Close Concats : ",uniquecloseconcats[i5]/*,"  CloseConcats: ",CloseConcats[i5]*/);
         i5--;
         i6--;
         }
      
      
      Print("Support and Resistance EA has finished");
//----
return(0);
}
//+------------------------------------------------------------------+

